﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.801
@EndOfDesignText@
'v1.00
Sub Class_Globals
	'Public SharedFolder As String
	Public UseFileProvider As Boolean
	'Private rp As RuntimePermissions
End Sub

Public Sub Initialize
	Dim p As Phone
	If p.SdkVersion >= 24 Or File.ExternalWritable = False Then
		UseFileProvider = True
		'SharedFolder = File.Combine(File.DirInternal, "shared")
		'SharedFolder = File.Combine( File.DirDefaultExternal, "FileToShare")
		'File.MakeDir("", SharedFolder)
	Else
		UseFileProvider = False
		'SharedFolder = rp.GetSafeDirDefaultExternal("shared")
		'SharedFolder = File.Combine( File.DirDefaultExternal, "FileToShare")
	End If
	
	'clear shared folder location on each load
'	If ClearSharedFolder(SharedFolder) = False Then
'		ToastMessageShow("Trouble clearing shared folder", True)
'	End If
End Sub
'Empty Shared Folder
Public Sub ClearSharedFolder(FileLocation As String) As Boolean
	
	Dim bB As Boolean = True
	For Each f As String In File.ListFiles(FileLocation)
		If File.Delete(FileLocation, f) = False Then
			bB = False
		End If
	Next
	Return bB
End Sub
'Returns the file uri.
Public Sub GetFileUri (FileLocation As String, FileName As String) As Object
	
	If UseFileProvider = False Then
		Dim uri As JavaObject
		Return uri.InitializeStatic("android.net.Uri").RunMethod("parse", Array("file://" & File.Combine(FileLocation, FileName)))
	Else
		Dim f As JavaObject
		f.InitializeNewInstance("java.io.File", Array(FileLocation, FileName))
		Dim fp As JavaObject
		Dim context As JavaObject
		context.InitializeContext
		fp.InitializeStatic("android.support.v4.content.FileProvider")
		Return fp.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
	End If
End Sub
'Replaces the intent Data field with the file uri.
'Resets the type field. Make sure to call Intent.SetType after calling this method
Public Sub SetFileUriAsIntentData (Intent As Intent, FileLocation As String, FileName As String)
	Dim jo As JavaObject = Intent
	jo.RunMethod("setData", Array(GetFileUri(FileLocation,FileName)))
	Intent.Flags = Bit.Or(Intent.Flags, 1) 'FLAG_GRANT_READ_URI_PERMISSION
End Sub